# Software installation on Windows

To follow the course practicals, you need a terminal and
[Git](http://git-scm.com/), both of which are easy to install on
[Linux](http://en.wikipedia.org/wiki/Linux) or Mac OSX. For Windows, there are
a number of options, described below.


## MobaxTerm

Most light-weight is to install something like
[MobaXterm](http://mobaxterm.mobatek.net/), which provides a terminal emulator
and can install other software from the Linux platform such as Git.

After opening MobaxTerm, use the following to install Git:

    apt-get install git libopenssl100


## VirtualBox

Using [VirtualBox](https://www.virtualbox.org/), you can run a complete Linux
installation in a virtual machine from Windows. For example, create a new
virtual machine with VirtualBox and install [Ubuntu](http://www.ubuntu.com/) in
it.


## Work on a remote machine

If you have an account on a remote Linux machine, you can connect to that using
[PyTTY](http://www.chiark.greenend.org.uk/~sgtatham/putty/download.html) or
[MobaXterm](http://mobaxterm.mobatek.net/) and work from there.